bind Entry <Shift-3>   {entry-start-move-drag %W %x %y}
bind Entry <Control-3> {entry-start-copy-drag %W %x %y}
bind Entry <3>         {entry-start-plain-drag %W}

proc entry-get-sel {w b e} {
    string range [$w get] [$w index $b] [expr [$w index $e]-1]
}
proc entry-compare {w i1 op i2} {
    expr [$w index $i1] $op [$w index $i2]
}

proc entry-start-plain-drag {w} {
    if ![dragdrop source $w issource] return
    global dragdropgenerator entrydragdrop
    lappend dragdropgenerator($w) STRING
    if {[$w selection present] && ![string length [$w cget -show]]} {
	set entrydragdrop(data) [entry-get-sel $w sel.first sel.last]
    } else {
	set entrydragdrop(data) [$w get]
    }
}
proc entry-start-copy-drag {w x y} {
    if ![dragdrop source $w issource] return
    if {[$w cget -state] == "disabled"} {
	entry-start-plain-drag $w
    } else {
	global dragdropgenerator entrydragdrop
	if {[$w selection present] && \
		![string length [$w cget -show]] && \
		[entry-compare $w sel.first <= @$x] && \
		[entry-compare $w sel.last >= @$x]} {
	    lappend dragdropgenerator($w) ENTRY-INTERNAL-COPY
	    set entrydragdrop(data) [entry-get-sel $w sel.first sel.last]
	    set entrydragdrop(first) [$w index sel.first]
	    set entrydragdrop(last) [$w index sel.last]
	    set entrydragdrop(source) $w
	}
    }
}
proc entry-start-move-drag {w x y} {
    if ![dragdrop source $w issource] return
    if {[$w cget -state] == "disabled"} {
	entry-start-plain-drag $w
    } else {
	global dragdropgenerator entrydragdrop
	if {[$w selection present] && \
		![string length [$w cget -show]] && \
		[entry-compare $w sel.first <= @$x] && \
		[entry-compare $w sel.last >= @$x]} {
	    lappend dragdropgenerator($w) ENTRY-INTERNAL-MOVE
	    set entrydragdrop(data) [entry-get-sel $w sel.first sel.last]
	    set entrydragdrop(first) [$w index sel.first]
	    set entrydragdrop(last) [$w index sel.last]
	    set entrydragdrop(source) $w
	}
    }
}
proc entry-can-drop {w x y i t} {
    global entrydragdrop
    if {$x == "" || $y == ""} {
	catch {
	    $entrydragdrop(can-drop) $w $x $y $i $t
	}
    }
    foreach ty $t {
	switch $ty {
	    STRING {
		if {[$w cget -state] != "disabled" && \
			![string length [$w cget -show]]} {
		    return 1
		}
	    }
	    ENTRY-INTERNAL-MOVE -
	    ENTRY-INTERNAL-COPY {
		if {("$i" != [tk appname] || \
			"$w" != $entrydragdrop(source) || \
			![string length [$w cget -show]] && \
			[entry-compare $w @$x < $entrydragdrop(first)] || \
			[entry-compare $w @$x > $entrydragdrop(last)]) &&\
			[$w cget -state] != "disabled"} {
		    return 1
		}
	    }
	    default {
		set r {}
		catch {
		    set cmd [concat $entrydragdrop(can-drop) \
			    [list $w $x $y $i [list $ty]]]
		    set r [eval $cmd]
		}
		if [llength $r] {
		    return $r
		}
	    }
	}
    }
    return 0
}
proc entry-drop-string {w x y i t d} {
    $w insert @$x $d
}
proc entry-drop-copy {w x y i t d} {
    global entrydragdrop
    send -- $i [$entrydragdrop(source) selection clear]
    set data [send -- $i [list set entrydragdrop(data)]]
    set sp [$w index @$x]
    $w insert $sp $data
    $w selection range $sp [expr $sp+[string length $data]]
    set entrydragdrop(data) {}
    set entrydragdrop(first) {}
    set entrydragdrop(last) {}
    set entrydragdrop(source) {}
}
proc entry-drop-move {w x y i t d} {
    global entrydragdrop
    set d [send -- $i [list set entrydragdrop(data)]]
    set f [send -- $i [list set entrydragdrop(first)]]
    set l [send -- $i [list set entrydragdrop(last)]]
    set s [send -- $i [list set entrydragdrop(source)]]
    if {"$s" != "$w"} {
	send -- $i [list $s delete $f $l]
	$w insert @$x $d
	$w selection range @$x [expr [$w index @$x]+[string length $d]]
    } elseif [entry-compare $w @$x < $f] {
	$w delete $f $l
	$w insert @$x $d
	$w selection range @$x [expr [$w index @$x]+[string length $d]]
    } else {
	$w insert @$x $d
	$w selection range @$x [expr [$w index @$x]+[string length $d]]
	$w delete $f $l
    }
    set entrydragdrop(data) {}
    set entrydragdrop(first) {}
    set entrydragdrop(last) {}
    set entrydragdrop(source) {}
}
proc entry-serve-string {w t} {
    global entrydragdrop
    return $entrydragdrop(data)
}
proc entry-serve-copymove {w t} {
    return {}
}
proc dragdrop-enable-entry {w} {
    if ![llength [dragdrop source $w datacmd STRING]] {
	dragdrop source $w datacmd STRING entry-serve-string
    }
    dragdrop source $w datacmd ENTRY-INTERNAL-COPY entry-serve-copymove
    dragdrop source $w datacmd ENTRY-INTERNAL-MOVE entry-serve-copymove

    set d [dragdrop destination $w dragcmd]
    if [llength $d] {
	global entrydragdrop
	set entrydragdrop(can-drop) $d
    }
    dragdrop destination $w dragcmd entry-can-drop

    dragdrop destination $w dropcmd ENTRY-INTERNAL-MOVE entry-drop-move
    dragdrop destination $w dropcmd ENTRY-INTERNAL-COPY entry-drop-copy
    if ![llength [dragdrop destination $w dropcmd STRING]] {
	dragdrop destination $w dropcmd STRING entry-drop-string
    }

    bindtags $w [concat [bindtags $w] dragdrop3]
}
