.\" Emacs, this is in -*- nroff -*- mode "
.\"
.\" BEGIN INCLUSION OF MANPAGE MACROS (some excluded)
'\"
'\" Copyright (c) 1990-1994 The Regents of the University of California.
'\" Copyright (c) 1994-1995 Sun Microsystems, Inc.
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\" END OF INCLUSION OF MAN MACROS
.\" ----------------------------------------------------------------------
.\" This next bit is snarfed from the groff tmac.an, so I suppose it
.\" must be under the GPL. "
.de C
.\" .it 1 an-trap "
.ft CR
.if !"\\$1"" \&\\$1 \\$2 \\$3 \\$4 \\$5 \\$6\\fR
..
.\" Not that I'm claiming to understand how it works... :^)
.\" ----------------------------------------------------------------------
.\"
.\" Everything else is my own! :^)
.\"
.\" You may do as you wish with this code, as long as you acknowledge
.\" my efforts within it and/or the documentation for it. Note that
.\" anyone using this code does so entirely at their own risk, as I
.\" don't guarentee its fitness for anything. 
.\"
.\" If you do have any problems with it (or with this documentation)
.\" then contact me and I will (probably) see what I can do to help.
.\"
.\" Donal K. Fellows - fellowsd@cs.man.ac.uk "
.TH dragdrop n "1st December 1995" "DragDrop 3.0" "Tk Extensions"
.BS
.SH NAME
dragdrop \- Drag-and-drop support for Tcl7.4+/Tk4.0+
.SH SYNOPSIS
\fBdragdrop \fIoption \fR?\fIarg arg ...\fR?
.SH "HELPER PROCEDURE SYNOPSIS"
.nf
.BI dragdrop_bind " window data_server generator \fR?\fIbutton\fR? ?\fInotifier\fR?"
.BI dragdrop_destination " window drag_handler types drop_handler"

.BI dragdrop-enable-text " window"
.BI dragdrop-enable-entry " window"

.BI supplies_string " window string"
.BI supply_string " window type"
.BI accepts_drop " x y source_app data_type_list"
.fi
.BE

.SH "VARIABLE SYNOPSIS"
.nf
.B dragdrop
.B dragdrop_version
.B dragdrop_patchLevel
.B dragdrop_library
.fi

.SH DESCRIPTION
This is an extension (written in C and Tcl) that provides inter- and
intra-interpreter drag-and-drop support for Tk4.0 (and later
versions).
.VS
Deleting the
.B dragdrop
command disables all drag-and-drop support. Renaming the command
changes the command used for all RPC interactions by the application,
so if you rename the command to the same thing in a group of
applications, then the user will be able to drag-and-drop between
those applications, but no others. Note that the
.B dragdrop
array is used by all implementations (changing this currently requires
alterations to the header files \- specifically
.I src/dragdropInt.h
in the definition of the
.C MAIN
macro). The legal forms of the command are:
.TP
.BI "dragdrop containing " "rootX rootY"
Returns the path name for the window containing the point given by
.I rootX
and
.IR rootY ,
much as in the
.BI "winfo containing " "rootX rootY"
command except that several extra checks are applied to the window
being returned (that it is mapped, and that it actually does contain
the point given, this latter being needed because of bugs in some
window managers, or so I expect.
.TP
.BI "dragdrop data " "type"
Returns the data from the source window implied by the
.I type
argument. \fIShould only be called by the drag-and-drop mechanism, and
not by the user of this extension.\fR 
.VE
.TP
.BI "dragdrop debug " "\fR?\fIboolean\fR?"
If
.I boolean
is specified, then the state of the debugging flag (global within
the scope of the current process) is updated to the value specified
.RI ( boolean
must have a proper boolean value, such as
.B 0
or
.BR yes ).
Debugging is off by default.
.TP
.BI "dragdrop destination " "window \fR?\fIoption arg ...\fR?" 
.VS
This command is used to manipulate the configuration of the drop
target
.IR window .
The behaviour of the command depends on the
.I option
argument. The following forms of the command are currently supported:
.RS
.TP
.BI "dragdrop destination " window
Equivalent to the
.BI "dragdrop destination " window " isdestination"
command.
.TP
.BI "dragdrop destination " window " dragcmd \fR?" command\fR? 
If
.I command
is specified, sets a command to be called to notify the destination
window that a drag is occurring over it. The command will have the
pathname of the target window, the x and y location of the mouse
pointer (relative to the target window), the source interpreter and
the list of types that the source interpreter is prepared to provide
all appended to it (as list elements) before execution. If the command
returns a true value (as determined by
.BR Tcl_GetBoolean )
then a drop is permitted at the current position, and a drop is not
permitted otherwise. If the
.I command
argument is not specified, then the current current command associated
with dragging actions over the window is returned. This command will
make window
.I window
into a drag-and-drop target if it is not one already. When the mouse
leaves the window (either because it moves to another window, or
because the dragging button is released), a command similar to the
above, except with the x and y locations specified as empty strings,
will be invoked to notify the target window that it is no longer under
a dragging cursor. In this case, the return value is ignored. If the
command defined for a window does not return success, then the command
for the toplevel containing that window is called (if it is defined).
At the termination of a drag operation within a window, the
.B dragcmd
will be called for the toplevel containing the window if it is
defined, and there is no
.B dragcmd
for the window itself.

Thus, if the command
.RS
.DS
.C "dragdrop destination .window dragcmd can_drop"
.DE
was issued, the command
.DS
.C "can_drop .window \fIx y srcInterp typeList"
.DE
would be executed every time the mouse moves over window
.I .window
during a drag operation, and the
command
.DS
.C "can_drop .window {} {} \fIsrcInterp typeList"
.DE
would be executed when the mouse leaves the window or the dragging
button is released over the window. If, instead, the command
.DS
.C "dragdrop destination . dragcmd can_drop_toplevel"
.DE
then the command issued for a drag over the window would be
.DS
.C "can_drop_toplevel .window \fIx y srcInterp typeList"
.DE
provided that there is no
.B dragcmd
defined for
.I .window
elsewhere.
.RE
.TP
.BI "dragdrop destination " window " dropcmd " "type \fR?\fIcommand\fR? ?\fIaftertype\fR?" 
If
.I command
is specified, sets a command to be called to notify the destination
window that a drop has occurred over it which offers data of type
.IR type .
The command will have the pathname of the target window, the x and y
location of the mouse pointer (relative to the target window), the
source interpreter, the type of the dropped data, and the data itself
(all formatted as proper lists) all appended to it before
execution. If the
.I command
argument is not specified, then the current current command associated
with dropping actions of the given type over the window is returned.
If the window
.I window
is not already a drag-and-drop target, this command will make it into
one, and if
.I command
is specified as an empty string, then the entry in the type list for
the type given will be removed. The return value from the dropping
action is always ignored.

The
.I aftertype
argument, where specified, says where in the list of types the type
associated with the command should be inserted. This should either be
a type already present in the list, or one of the special symbols:
.RS
.RS
.TP
.B first
Make the type first in the list of types.
.TP
.B last
Make the type last in the list of types.
.RE

This matters because, in determining what type to accept, the
drag-and-drop mechanism considers the types in the order specified in
this list, with the mechanism preferring types earlier in the list. If
this argument is left unspecified, the type will be appended to the
list if it is not already present in the list, and otherwise left in
its current location. If there is no matching type for the widget,
then the type list for the toplevel window containing the widget is
also searched for a match.

Thus, if the command
.DS
.C "dragdrop destination .window dropcmd \\\\ "
.C "        STRING drop_data first"
.DE
was issued, the command
.DS
\fCdrop_data .window \fIx y srcInterp \fCSTRING\fI data\fR 
.DE
would be executed when the dragging button for a dragging action is
released over
.I .window
and one of the types of data offered during the data transfer is
STRING, with this taking preference over all other data types.
.RE

.TP
.BI "dragdrop destination " window " forget"
This makes window
.I window
cease to be a drag-and-drop destination.
.TP
.BI "dragdrop destination " window " isdestination"
This asks whether window
.I window
is a drag-and-drop destination, returning a boolean value.
.TP
.BI "dragdrop destination " window " types"
This returns the list of types of data accepted by window
.I window
in the current order of preference. An empty string is returned if no
types of data are currently accepted (either because no dropping
handlers are defined, or because the window is not a drag-and-drop
target).
.RE

.TP
.BI "dragdrop drag " "rootX rootY"
Updates the drag-and-drop mechanism to take account of the (specified)
position of the mouse if called during a dragging action, and ignored
otherwise. Should be bound to the appropriate modified motion binding
for the dragging button associated with a particular window.
.TP
.BI "dragdrop drop " "rootX rootY"
Terminates the current drag-and-drop action at the given coordinate,
causing a transfer of data to occur at this point if the there is an
accepting target below the pointer, returning the type of the data
that was transferred.  Has no effect if a drag is not in progress.
Should be bound to the appropriate button release binding for the
dragging button associated with a particular window.
.TP
.BI "dragdrop library"
Returns the name of the library directory in which standard
drag-n-drop scripts are stored.  This is actually the value of the
.B dragdrop_library
variable and may be changed by setting
.BR dragdrop_library . 
.TP
.BI "dragdrop move " "rootX rootY sourceInterp"
Propagates the current dragging position to the destination
interpreter, causing a check to see if any of the offered data types
can be accepted. \fIShould only be called by the drag-and-drop mechanism,
and not by the user of this extension.\fR 
.TP
.BI "dragdrop patchLevel"
Returns the current value of the
.B dragdrop_patchLevel
variable.
.TP
.BI "dragdrop reset"
Resets the internal dragging status flag. Only use if a drag has
somehow terminated without a call of the
.B dragdrop drop
command, and the drag-and-drop mechanism has thus become confused.
.TP
.BI "dragdrop set " "rootX rootY sourceInterp"
Propagates the drop position to the destination
interpreter, causing a transfer of data of a type offered by the
source and accepted by the destination, with the destination choosing
what type by the method specified in the comments on the
.BI "dragdrop destination " window " dropcmd"
command above. \fIShould only be called by the drag-and-drop
mechanism, and not by the user of this extension.\fR
.TP
.BI "dragdrop source " "window \fR?\fIoption arg ...\fR?" 
This command is used to manipulate the configuration of the drag
source
.IR window .
The behaviour of the command depends on the
.I option
argument. The following forms of the command are currently supported:
.RS
.TP
.BI "dragdrop source " window
Equivalent to the
.BI "dragdrop source " window " issource"
command.
.TP
.BI "dragdrop source " window " datacmd " "type \fR?\fIcommand\fR?" 
If
.I command
is specified, then this updates the command that will be executed to
generate the data requested of type
.IR type .
This command will only be executed when the data is actually requested
by the destination side of a drag-and-drop operation during a drop
action. If
.I command
is specified as an empty string, then the data generator command for
the given type is removed, and if
.I command
is not specified at all, then the current data generator command is
returned. If a command is given and the window is not a drag-and-drop
source, then it is made into one, though this also really requires
some bindings to be made as well. If no
.B datacmd
is specified for a particular requested type in a particular window,
then the
.B datacmd
for the toplevel containing that window is called (provided it is
defined).

When invoked, the data generator command has the name of the window
for which it is serving data and the type of the data requested
appended (as proper lists) before execution. Thus, if the command
.RS
.DS
.C "dragdrop source .window datacmd STRING get_some_data"
.DE
was issued, the command
.DS
.C "get_some_data .window STRING"
.DE
would be executed when a drag-and-drop action starting at
.I .window
requests some data of type STRING in the droping phase of the action.
.RE
.TP
.BI "dragdrop source " window " forget"
This makes window
.I window
cease to be a drag-and-drop source (though the drag-and-drop bindings
for the window should really be removed as well).
.TP
.BI "dragdrop source " window " issource"
This asks whether window
.I window
is a drag-and-drop source, returning a boolean value.
.TP
.BI "dragdrop source " window " notify " \fR?\fIcommand\fR? 
If
.I command
is specified, then this updates the command that will be executed to
notify the source window
.I window
of the status of drag-and-drop actions that start from it.  If
.I command
is specified as an empty string, then the status notification command
for the given type is removed, and if
.I command
is not specified at all, then the current status notification command
is returned.  This also makes
.I window
into a drag-and-drop source if it was not already one (and a command
is specified). If a source window has no
.B notify
command, but the toplevel containing that window does have a
.B notify
command, then that will be called instead (with exactly the same
arguments).

Currently definied notification actions are as follows:
.RS
.TP
.IB command " startat " "srcWindow rootX rootY"
A drag-and-drop action has started in
.I srcWindow
at the given absolute location.
.TP
.IB command " able " "srcWindow rootX rootY destInterp destWindow"
A drag-and-drop action started in
.I srcWindow
is able to drop in
.I destWindow
of interpreter
.I destInterp
at the given absolute location.
.TP
.IB command " unable " "srcWindow rootX rootY"
A drag-and-drop action started in
.I srcWindow
is unable to drop at the given absolute location.
.TP
.IB command " dropped " "srcWindow rootX rootY destInterp destWindow"
A drag-and-drop action started in
.I srcWindow
has succeeded in dropping data in
.I destWindow
of interpreter
.I destInterp
at the given absolute location.
.TP
.IB command " failed " "srcWindow rootX rootY"
A drag-and-drop action started in
.I srcWindow
has failed to drop any data at the given absolute location.
.RE
.TP
.BI "dragdrop source " window " types"
Returns a list of all the types that window
.I window
knows how to serve, in no particular order. An empty list will be
returned if no data generators are defined, or if
.I window
is not a drag-and-drop source.
.RE
.TP
.BI "dragdrop start " "rootX rootY offeredTypes"
Starts a drag-and-drop action at the absolute location indicated,
offering types
.I offeredTypes
for transfer. Should be bound to the appropriate button press binding
for the dragging button associated with a particular window.
.TP
.BI "dragdrop version"
Returns the current value of the
.B dragdrop_version
variable.
.RE

Providing drag-and-drop support for entries and text widgets is
simple, as there are predefined procedures to do just that:
.DS
.BR dragdrop-enable-text ", and"
.BR dragdrop-enable-entry
.DE

These procedures make their target window (given by the argument) into
a drag-and-drop source and destination, capable of allowing data to be
dragged about using the third mouse-button (mainly because it doesn't
clash with any of the standard Tk bindings). These enhanced text
(entry) widgets will generate and accept data packets of type
\fCSTRING\fR, \fCTEXT-INTERNAL-COPY\fR (\fCENTRY-INTERNAL-COPY\fR) and
\fCTEXT-INTERNAL-MOVE (\fCENTRY-INTERNAL-MOVE\fR), with the last two
being done by holding down the Control (Shift) key while beginning the
drag. No moving from a disabled text or entry widget is allowed (the
same is true for show-restricted entries), and no widget accepts data
that it cannot consume. The only caveats are the
.B dragcmd
associated with these widgets will change to another procedure (which
actually chains the old procedure) and the fact that you need to add
the information out the non-standard types that you are prepared to
supply. Luckily the latter is easy - add something like
.DS
.C "set dragdropgenerator(%W) \fITYPE\fR" 
.DE
to the widget binding for button 3.
.VE

In order to facilitate the use of simple drag-and-drop schemes, the
Tcl procedures
.B dragdrop_bind
and
.B dragdrop_destination
are provided. They implement a simple user interface to the
drag-and-drop code, though for complex bindings it is necessary to
access
.BR "dragdrop start" ", " "dragdrop drag" " and " "dragdrop drop"
directly.
.BR supply_string ,
.B supplies_string
and
.B accepts_drop
are sample procedures for the drag-and-drop servers and control
routines, and their use of all these procedures is demonstrated in
.BR dragdrop_demo (1).

.BR dragdrop 
is an array used internally to the drag-and-drop system. Most of the
members should not be modified by the user (except where duplicating
the action of
.B dragdrop_bind
or
.BR dragdrop_destination ),
but there are two user-modifiable members of the
.B dragdrop
array:
.TP
.B "dragdrop(yes)"
The cursor used when it is possible to drop data at the current
position, in any form acceptable to 
.BR Tk_GetCursor (3).
.TP
.B "dragdrop(no)"
The cursor used when it is not possible to drop data at the current
position, in any form acceptable to 
.BR Tk_GetCursor (3).

.SH "THE DRAG-AND-DROP PROTOCOL"
The drag-and-drop protocol is built directly on top of the Tk
.B send
command which implements a RPC mechanism between Tk4.0 (and possibly
later) applications sharing the same display.
.\" \fBNote that the protocol described here is not the one actually
.\" implemented in Dragdrop 3.0, though it is very similar, and such
.\" changes as have been made are there to increase the reliability of the
.\" protocol as well as the degree of encapsulation.\fR"
.SS "SERVER SIDE"
A drag operation commences with a call to
.B dragdrop start
with the absolute location of the mouse cursor when the button was
depressed and the types that the source window is willing to supply.
The procedure sets up internal variables so that the rest of the calls
that form part of the drag-and-drop protocol work. As part of this it
calls the
.I notify
command associated with the source window with the
.B startat
parameter. The last stage of this part of the protocol is an
invocation of the next stage of the process
.RB ( "dragdrop drag" )
to set up the cursor, dependant on whether the window will accept
drops from itself.

Moving the mouse with the button depressed causes calls to be made to
.B dragdrop_drag
with the absolute location of the mouse cursor. The list of current
interpreters is searched for an interpreter that has a window that
covers the given point (equivalent to invoking the
.DS
.BI "winfo containing " "x y"
.DE
command in every interpreter, except with extra some checks that are
performed by the
.B dragdrop containing
command). In order to speed this process up, the first process checked
is the process that last succeeded at this operation (allowing motion
within an interpreter to be handled much more efficiently).  If an
interpreter is found, it checks to see if this was the window that the
cursor was in at the previous call to this function, and if this not
the case, sends a message to old destination interpreter indicating
that it has lost the mouse cursor.

Then, a message is sent to the new remote interpreter (using the
.B dragdrop move
command, telling it the current location of the mouse cursor and the
name of the interpreter initiating the drag-and-drop action, and
asking whether a drop is allowable at that location. Then, on the
basis of the information returned, it configures the cursor and calls
the
.I notify
command with either the 
.B able
or the
.B unable
parameters.

Upon the release of a mouse button, the
.B dragdrop drop
command is called with the location of the mouse cursor. The
destination window is determined using the same method as in
.B dragdrop drag
above (actually a call to the same internal routine), and that window
is informed that the mouse pointer has left it, and that message is
immediately followed by a message stating that a drop has occurred
from the source application (by remote invocation of the
.B dragdrop set
command). Finally the procedure resets the mouse cursor to normal, and
calls the
.I notify
command with either the
.B dropped
or the
.B failed
parameters, depending upon the success of the drop.

A window is considered to be a valid drop zone if:
.TP
[1]
its interpreter has the command
.BR dragdrop ,
.TP
[2]
it is the uppermost window under the mouse cursor,
.TP
[3]
the window is mapped,
.TP
[4]
the window actually contains the point mentioned (both of these
previous two conditions are needed to cope with what I suspect to be
bugs in some window managers), and
.TP
[5]
the patchlevel of the dragdrop mechanism at the remote end matches
that at the source end.
.RE

The final element of the source side of the drag-and-drop mechanism
.RB ( "dragdrop data" )
merely returns the data of the requested type from the source window
(the window used as the source for this operation is that which is
cached by the mechanism), and is there to be invoked directly from the
far end of the communication.

.SS "CLIENT SIDE"
During a drag operation, calls are made to the procedure
.B dragdrop move
whenever the mouse is moved with the button down. If the location
given in the arguments is a valid one, then it updates the list of
data types that the source interpreter is willing to supply if it
doesn't already have the current value, and calls the drag handler to
determine if the window actually wants data dropped at the current
location.

If the location is invalid, then the message sent was really saying
that the mouse cursor had left the window, which should be notified of
the fact.

Drop operations are performed when the server makes a RPC to
.B dragdrop set
which transfers the supplied type list if it hasn't already been, and
attempts to match it against the list of types accepted (with the
acceptance list determining the order of preference). If a match is
found, then the data corresponding to the matched type is transferred
by making a RPC to the server routine
.B dragdrop data
and the drop handler for the destination window is called with the
type of the transferred and the data itself, in addition to
destination window, the source interpreter, and the coordinates of the
drop location, relative to the destination window.

.SH "TYPES OF DATA"
The type description codes used by the drag-and-drop package may be
any (preferably short) strings that do not contain the null character
(due to underlying system implementations), but it is recommended that
the type codes be restrained to the upper case character, the dash
(minus) and number symbols, as this helps type codes stand out from
the text surrounding them and can aid greatly in debugging.

There are no fixed guidelines for these symbols, but the following
symbols should be treated as being fixed for the sake of
compatability:
.TP
.C STRING
Plain textual data.
.TP
.C FILENAME
Untyped file reference (filing system specific)
.TP
.C TYPEDFILENAME
A tcl list where the first element is a code describing the type of
the file, and the second element is the name of the code as in
\fCFILENAME\fR.

Suggested filename types include:
.RS
.TP
.C TEXT
Plain text
.TP
.C HTML
Hypertext Markup Language source
.TP
.C C
C language source
.TP
.C TCL
Tcl source
.TP
.C XBM
X11 bitmap
.TP
.C PPM
Portable pixmap (raw-bits)
.TP
.C GIF
Graphics interchange format (may have
.C -87
or 
.C -89
to specify the version)
.TP
.C COMPRESSED
File compressed with
.BR compress (1).
.TP
.C GZIPPED
File compressed with
.BR gzip (1).
.TP
.C UUENCODED
File encoded with
.BR uuencode (1).
.TP
.C EXECUTABLE
File which may be executed in the context of the application
generating the original message. This should only be allowed if the
file is allowed to be executed (execute permission for the user) and
can physically be executed by the architecture that would run it. It
is anticipated that where 
.C EXECUTABLE
file references are passed, there will follow further IPC between the
source and destination applications in order to determine where and
how to actually run the application.
.TP
.C DIRECTORY
The name passed refers to a directory, and not an ordinary file.
.RE
.IP
These file types may be combined into a space-separated list, with the
leading type having precedence over the others (so
.I foo.html.gz.uue
might have the file type list \fCUUENCODED GZIPPED HTML\fR)
.TP
.C URL
Uniform resource locator.
.TP
.C LIST
List of pairs, where the first element of each pair (really a two
element list) is the type of the second element.
.TP
.C ENTRY-INTERNAL-MOVE
.VS
Used for moving selected text between entries. Do not support except
through the default interface for entries
.RB ( dragdrop-enable-entry ).
.TP
.C ENTRY-INTERNAL-COPY
Used for copying selected text between entries. Do not support except
through the default interface for entries
.RB ( dragdrop-enable-entry ).
.TP
.C TEXT-INTERNAL-MOVE
Used for moving selected text between entries. Do not support except
through the default interface for entries
.RB ( dragdrop-enable-text ).
.TP
.C TEXT-INTERNAL-COPY
Used for copying selected text between entries. Do not support except
through the default interface for entries
.RB ( dragdrop-enable-text ).
.VE
.PP
Where a you want to define a new type which you want to be private to
only a few applications (i.e. not for general use) then you should
precede the name with
.C X-LOCAL-
to avoid confusion.
.\".SH "SEE ALSO"
.\".BR dragdrop (n)
.\".SH AUTHOR
.\"Donal K. Fellows, \fCfellowsd@cs.man.ac.uk\fR

.\" .SH "CREATING A DRAG-AND-DROP SERVER"
.\" The command
.\" .RS
.\" 
.\" .BI dragdrop_bind " widget data_server generator button ?notifier?"
.\" 
.\" .RE
.\" makes the widget described by the
.\" .I widget
.\" argument a source of drag-and-drop data. The other arguments are:
.\" .TP
.\" .I "data_server"
.\" Specifies a procedure to call to supply the data requested when during
.\" a drop. This takes the arguments:
.\" .RS
.\" .TP
.\" .I widget
.\" the source widget
.\" .TP
.\" .I type
.\" type of data requested
.\" .RE
.\" .TP
.\" .I "generator"
.\" This is a script to evaluate at the start of a drag operation which
.\" informs the dragging engine of the types of data which the data_server
.\" is capable of supplying (
.\" .I i.e.
.\" it supplies a list of the acceptable types). It can also be used to
.\" move the relevant parts of the state of the source widget into a
.\" temporary buffer. See
.\" .BR dragdrop_types (7)
.\" for details of the type scheme.
.\" .TP
.\" .I "button"
.\" This is which mouse button the dragging operation should be bound
.\" to. Ideally this would be button 1, but this tends to conflict with
.\" other bindings on the widget, so great care should be exercised where
.\" such a tactic is adopted. It is expected that, in order to avoid
.\" clashes, button 3 will be the standard for dragging and dropping,
.\" though this is left entirely to the programmer.
.\" .TP
.\" .I "notifier"
.\" This is the name of a procedure to call to signify the progress of the
.\" current dragging operation (defaults to none). The first argument
.\" indicates what sort of message is being passed. The actual forms
.\" generated are:
.\" .RS
.\" .TP
.\" .IB notifier " startat " "widget x y"
.\" This call is generated when the mouse button is pressed to begin the
.\" drag operation, and could be used to bring up a window indicating the
.\" data being carried by the drag operation.
.\" .TP
.\" .IB notifier " able " "widget x y drop_interpreter drop_widget"
.\" This call is generated when a drop operation would be possible at the
.\" .I drop_widget
.\" given in the
.\" .I drop_interpreter.
.\" This is only generated from mouse movement with the button down.
.\" .TP
.\" .IB notifier " unable " "widget x y"
.\" This call is generated when a drop operation would not be bossible at
.\" the current location (either because you are not over a Tk4
.\" application, or the widget you are currently over does not support
.\" dropping at the current location in the destination
.\" widget/interpreter). This is only generated from mouse movement with
.\" the button down.
.\" .TP
.\" .IB notifier " dropped " "widget x y drop_interpreter drop_widget"
.\" This call is generated when the data has been successfully dropped
.\" into the
.\" .I drop_interpreter
.\" at the location 
.\" .I x,y
.\" which lies within the 
.\" .I drop_widget.
.\" This can be used to withdraw or destroy any windows created by the
.\" .B startat 
.\" call and to also delete the data from the source widget if this is so
.\" required. This is only generated by a release of the dragging button.
.\" .TP
.\" .IB notifier " failed " "widget x y"
.\" This call is generated when the drag-and-drop engine failed to
.\" transfer the data from the source to any destination, and is called
.\" when the dragging button is released. It can be used to delete or
.\" withdraw any windows created by the 
.\" .B startat
.\" call.
.\" .RE
.\" 
.\" .PP
.\" An example usage of the
.\" .B dragdrop_bind
.\" command is:
.\" .RS
.\" .nf
.\" \fCpack [entry .e]
.\" dragdrop_bind .e supply_string {
.\" 	supplies_string .e [.e get]
.\" } 3\fR
.\" .fi
.\" .RE
.\" .PP
.\" This creates an entry widget and makes it into a source for
.\" drag-and-drop operations. It only supplies data of type
.\" .I STRING
.\" where the data supplied is the contents of the entry, as supplied by
.\" the \fC.e get widget\fR command.
.\" .SH "CREATING A DRAG-AND-DROP CLIENT"
.\" The command
.\" .RS
.\" 
.\" .BI dragdrop_destination " widget drag_handler types drop_handler"
.\" 
.\" .RE
.\" makes the widget described by the
.\" .I "widget"
.\" argument a destination for drag-and-drop data. The other arguments
.\" are:
.\" .TP
.\" .I "drag_handler"
.\" This is a procedure which returns a boolean value (as determined by
.\" .BR Tcl_GetBoolean (3))
.\" stating whether a drop operation is possible at the location given
.\" within the widget, this information being used to select the cursor
.\" used, so relaying whether a drop would succeed to the user. The
.\" procedure is called as:
.\" 
.\" .RS
.\" .RS
.\" .I "handler widget x y source_interpreter data_types"
.\" .RE
.\" .RE
.\" 
.\" .RS
.\" The arguments passed are:
.\" .TP
.\" .I widget
.\" The widget underneath the mouse cursor.
.\" .TP
.\" .I x y
.\" The coordinates of the mouse cursor. These coordinates are relative to
.\" the origin of the window in where the drag is located (like the %x and
.\" %y substitutions in binding scripts). If these are empty strings then
.\" the mouse cursor has left the widget.
.\" .TP
.\" .I source_interpreter
.\" The interpreter which will supply the data to be dropped.
.\" .B NB
.\" The data is not necessarily available at this point.
.\" .TP
.\" .I data_types
.\" List of types of data that the
.\" .I source_interpreter
.\" is prepared to supply the data as.
.\" .RE
.\" 
.\" .TP
.\" .I "types"
.\" This is a list of the types accepted by the 
.\" .I drop_handler 
.\" of the widget in order of preference. The drag-and-drop mechanism
.\" selects the first member of this list that the data source is prepared
.\" to supply and retrieves the data associated to this type from the
.\" source. Some suggested types are listed elsewhere in this document.
.\" .TP
.\" .I "drop_handler"
.\" This is a procedure which performs the actual handling of the dropped
.\" data. It is called as:
.\" 
.\" .RS
.\" .RS
.\" .I "handler widget x y source_interpreter data_type data"
.\" .RE
.\" .RE
.\" 
.\" .RS
.\" The arguments passed are:
.\" .TP
.\" .I widget
.\" The widget underneath the mouse cursor.
.\" .TP
.\" .I "x y"
.\" The coordinates of the mouse cursor. These coordinates are relative to
.\" the origin of the window in which the drop occurred (as in the %x and
.\" %y substitutions in binding scripts). If these are empty strings then
.\" the mouse cursor has left the widget.
.\" .TP
.\" .I source_interpreter
.\" The interpreter that supplied the data dropped.
.\" .TP
.\" .I data_type
.\" The type of the data dropped.
.\" .TP
.\" .I data
.\" The data dropped.
.\" .B NB.
.\" This data is not necessarily still available in the
.\" .I source_interpreter
.\" .RE
.\" .PP
.\" An example usage of the
.\" .B dragdrop_destination
.\" command is:
.\" .RS
.\" .nf
.\" \fCproc drop_on_listbox {w x y s t d} {
.\" 	$w insert end {}
.\" 	$w insert "@$x,$y" $d
.\" 	$w delete end
.\" }
.\" pack [listbox .l]
.\" dragdrop_destination .l accepts_drop STRING drop_on_listbox\fR
.\" .fi
.\" .RE
.\" .PP
.\" This creates a listbox widget and makes it into a destination for
.\" drag-and-drop operations. It only accepts data of type
.\" .I STRING
.\" and the data supplied is inserted into the listbox at the position
.\" given by the point where the mouse button was released.
.\" "
.SH "DESCRIPTION OF VISIBLE STATE"
The drag-and-drop system uses one user-visible array:
.DS
.B dragdrop
.DE
This contains the main state of the system, with the following fields:

.TP
.I yes
cursor (in form acceptable to 
.BR Tk_GetCursor (3))
to use when a drop is possible. Defaults to an arrow, which will be
coloured green unless the
.I MONOCHROME
symbol is defined in the extension header (or makefile), or the root
window is determined to be monochrome (by examination of the visual
installed).
.TP
.I no
cursor (in form acceptable to 
.BR Tk_GetCursor (3))
to use when a drop is not possible. Defaults to a circle, which will
be coloured red unless the
.I MONOCHROME
symbol is defined in the extension header (or makefile), or the root
window is determined to be monochrome (by examination of the visual
installed).
.TP
.I types
possible types of data to transfer.
.TP
.I source
source interpreter (in destination).
.TP
.I widget
source window.
.TP
.I cursor
original cursor used in source window.
.TP
.I rmt_widget
destination window (used for caching)
.TP
.I rmt_interp
destination interpreter (used for caching)
.TP
.I "supplies,*"
temporaries used by
.B supply_string
and
.B supplies_string
.SH FILES
.TP
.I src/*.[ch]
Implements the drag-and-drop protocol (the
.BR dragdrop
command)
.TP
.I lib/interface.tcl
Implements a sample programmers interface to the drag-and-drop
protocol (procedures
.BR dragdrop_bind ,
.BR dragdrop_destination ,
.BR supplies_string ,
.BR supply_string ", and"
.BR accepts_drop )
.TP
.I lib/text.tcl
.VS
Implements standard drag-and-drop behaviour for text widgets.
.TP
.I lib/entry.tcl
Implements standard drag-and-drop behaviour for entry widgets.
.VE
.TP
.I man/*.[1n]
Documentation (in nroff form, tested using
.IR groff )
.SH "SEE ALSO"
.BR Tcl_GetBoolean (3),
.BR Tk_GetCursor (3),
.BR dragdrop (7),
.BR dragdrop_demo (1),
.BR dragdrop_types (7),
.BR send (n).
.SH BUGS
Does not handle multiple displays properly. Mind you, the
.B send
command didn't until very recently, apparently (according to the
changes file at least). Actually, it is not having multiple displays
open that is a problem, but rather that the main windows of the
interpreters must currently be on the same display...

There was something else, but I've forgotten what it was...
.SH "TO DO"
Check that this works with Tk4.1 and see if it happy as a `load'ed
extension (I don't see why this shouldn't work unless Tk4.1 lacks a
particular internal function which I call directly since it
circumvents rather a lot of fiddling around at the Tcl level).

Put some support for fancy multi-colour cursors in. Unfortunately,
this is not trivial, as it requires finding out about the shaped
window extension... Help with this would be highly appreciated.

Add proper drag and drop support to other publically available code of
mine.
.SH AUTHOR
Donal K. Fellows, 
.C fellowsd@cs.man.ac.uk
